;RELATIVE.LSP  (C) Copyright 1995, Planning_Systems

(defun RELATIVE (/
                   angle1 angle2 angle3
                   coordr coordx coordy
                   dcl_id
                   disth1 disth2 disth3
                   distx1 distx2
                   disty1 disty2
                   ptbase
                   relhyp
                   retrnx retrny
                   shiftx shifty
                   deg rad
                )

       (setq dcl_id (load_dialog "RELATIVE.DCL"))
       (if (not (new_dialog "RELATIVE" dcl_id)) (exit))

       (start_image "image")
       (slide_image 0 0
                    (- (setq coordx (dimx_tile "image")) 1)
                    (- (setq coordy (dimy_tile "image")) 1)
                    "RELATIVE"
       )
       (end_image)

       (setq coordx (float coordx)
             coordy (float coordy)
             coordr (/ coordx coordy)
       )

       (if (<= coordr 1)
           (setq shiftx 0
                 shifty (/ (+ (- coordy coordx) (- coordy (/ coordy 1.0))) 2))
           (setq shifty 0
                 shiftx (/ (+ (- coordx coordy) (- coordx (* coordx 1.0))) 2))
       )

       (setq angle2 0.0
             disth2 0.0
             distx2 0.0
             disty2 0.0)
       (tile_set)

       (action_tile "image" "(coord_xy $x $y)" )
       (action_tile "eb1" "(angl_val (distof $value))" )
       (action_tile "eb2" "(dist_hyp (distof $value))" )
       (action_tile "eb3" "(dist_axx (distof $value))" )
       (action_tile "eb4" "(dist_axy (distof $value))" )

       (action_tile "accept" "(done_dialog)" )

       (start_dialog)
       (unload_dialog dcl_id)
       (mov_dist angle2 disth2)
)

(defun mov_dist (angle3 disth3)
       (setq ptbase (getvar "lastpoint")
             angle3 (D2R angle3))
       (if (and disth3 ptbase)
           (setvar "lastpoint" (polar ptbase (+ (getvar "angbase") angle3) disth3)
)      )   )

(defun coord_xy (retrnx retrny)

       (setq retrnx (+ shiftx (- (float retrnx) (/ coordx 2)))
             retrny (- shifty (- (float retrny) (/ coordy 2)))
             relhyp (sqrt (+ (* retrnx retrnx) (* retrny retrny)))
       )
       (if (> relhyp 0)
           (setq angle2 (R2D (atan (/ retrny relhyp) (/ retrnx relhyp))))
       )
       (if (< angle2 0) (setq angle2 (+ 360 angle2)))

       (if (> relhyp 40)           
           (cond ((< angle2  22.5 ) (setq angle2   0.0 ))
                 ((< angle2  67.5 ) (setq angle2  45.0 ))
                 ((< angle2 112.5 ) (setq angle2  90.0 ))
                 ((< angle2 157.5 ) (setq angle2 135.0 ))
                 ((< angle2 202.5 ) (setq angle2 180.0 ))
                 ((< angle2 247.5 ) (setq angle2 225.0 ))
                 ((< angle2 292.5 ) (setq angle2 270.0 ))
                 ((< angle2 337.5 ) (setq angle2 315.0 ))
                 ((< angle2 360.0 ) (setq angle2   0.0 ))
       )   )
       (dist_set) (tile_set)
)

(defun angl_val (angle1)
       (if (= 'real (type angle1))
           (progn
                 (setq angle2 angle1)
                 (dist_set) (tile_set)
           )
           (err_tile)
)      )

(defun dist_hyp (disth1)
       (if (= 'real (type disth1))
           (progn
                 (setq disth2 disth1)
                 (dist_set) (tile_set)
           )
           (err_tile)
)      )

(defun dist_axx (distx1)
       (if (= 'real (type distx1))
           (progn
                 (setq distx2 distx1)
                 (angl_set) (tile_set) 
           )
           (err_tile)
)      )

(defun dist_axy (disty1)
       (if (= 'real (type disty1))
           (progn
                 (setq disty2 disty1)
                 (angl_set) (tile_set)
           )
           (err_tile)
)      )

(defun angl_set ()
       (setq disth2 (sqrt (+ (* distx2 distx2) (* disty2 disty2))))
       (if (> disth2 0)
           (setq angle2 (R2D (atan (/ disty2 disth2) (/ distx2 disth2))))
)      )

(defun dist_set ()
       (setq distx2 (* (cos (D2R angle2)) disth2)             
             disty2 (* (sin (D2R angle2)) disth2)
)      )

(defun tile_set ()
       (set_tile "eb1" (angtos (D2R angle2)))
       (set_tile "eb2" (rtos disth2))
       (set_tile "eb3" (rtos distx2))
       (set_tile "eb4" (rtos disty2))
       (set_tile "error" "")
)

(defun err_tile ()
       (set_tile "error" "Error:  Non-Numeric Data.")
)

(DEFUN D2R(deg) (* pi (/ deg 180.0)))
(DEFUN R2D(rad) (* 180.0 (/ rad pi)))

(princ)
